// ======================== Atmega128 ׷ LCD ׽Ʈ α׷ ==============
//  CPU : ATmega128-16M - 128*64 ׷ LCD
//     ¥ : 2006-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : CodeVisionAVR 
//      : serial 19200,N,8,1
// ----------------------------------------------------------------------------
// ⺻ 
#include <mega128.h>							// CPU  

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <float.h>
#include <math.h>
#include <string.h>
#include <delay.h>

//  
#include "cpusetup.inc"							// cpu  ͷƮ  ƾ
#include "glcd.inc"							// ׷ LCD

// Լ 
void main_menu_disp(void);						//  ޴ ǥ

//  

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
int main(void)
{
char buf[50];

	cpu_setup();							// cpu ʱȭ
	Lcd_Init();							// LCD ʱȭ
	main_menu_disp();						//  ޴ ǥ
	Putsxyt_f(1,1,"ϼ ѱ TEST");				// ׷ ǥ ڿ ǥ
	Putsxyt_f(1,2,"www.cpuplaza.com");				// ׷ ǥ ڿ ǥ
	while(1){
		if(com1_rx_eflg){					// COM1  ˻
			if(com1_rx_data == '1') Clrscr();		// ȭ 
			else if(com1_rx_data == '2') Cleardevice();	// ȭ 
			else if(com1_rx_data == '3') Putpixel(0,0,_WHITE);// ȼ ǥ
			else if(com1_rx_data == '4') Putpixelb(0,1,0xff,_WHITE);// Ʈ  ǥ()
			else if(com1_rx_data == '5') Putch('1');	// 1 ǥ
			else if(com1_rx_data == '6') Putchxy(16,2,'2');	// ׷ ǥ 1 ǥ
			else if(com1_rx_data == '7') Putchxyt(8,3,'3');	// ؽƮ ǥ 1 ǥ
			else if(com1_rx_data == '8'){
				sprintf(buf,"");			// ѱ ڿ
				Puts(buf);				// ڿ ǥ
				Puts_f("");				// CODE ڿ ǥ
			}
			else if(com1_rx_data == '9'){
				sprintf(buf,"׽Ʈ1");
				Putsxy(10,3,buf);			// ׷ ǥ ڿ ǥ
				Putsxy_f(10,20,"׽Ʈ1");		// ׷ ǥ CODE ڿ ǥ
			}
			else if(com1_rx_data == 'a'){
				sprintf(buf,"׽Ʈ2");
				Putsxyt(4,2,buf);			// ؽƮ ǥ ڿ ǥ
				Putsxyt_f(4,3,"׽Ʈ2");		// ؽƮ ǥ ڿ ǥ
			}
			else if(com1_rx_data == 'b'){			//  پϰ ׸
				Line(0,0,127,0);			// 簢 ڽ
				Line(127,0,127,63);
				Line(127,63,0,63);
				Line(0,0,0,63);

				Line(0,32,127,32);			// +
				Line(64,0,64,63);

				Line(0,0,127,63);			// 밢
				Line(0,63,127,0);
			}
			else if(com1_rx_data == 'c') Rectangle(10,10,118,54);// 簢ڽ ׸
			else if(com1_rx_data == 'd') Rectanglefill(10,10,118,54);// ä 簢ڽ ׸
			else if(com1_rx_data == 'e') Circle(64,32,10);	//  ׸
			else if(com1_rx_data == 'f') Ellipse(64,32,20,10);// Ÿ ׸
			else if(com1_rx_data == 'g') Setcolor(_WHITE);	//   WHITE
			else if(com1_rx_data == 'h') Setcolor(_BLACK);	//   BLACK
			else putchar(com1_rx_data);
			com1_rx_eflg = 0;
		}
	}
	return 0;
}

// =====================================  ޴ ǥ =======================
// [μ] void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	printf("\r\n");
	printf("========== LCD Test Main =========\r\n");
	printf("- 1 : Clrscr                     -\r\n");
	printf("- 2 : Cleardevice                -\r\n");
	printf("- 3 : Putpixel                   -\r\n");
	printf("- 4 : Putpixelb                  -\r\n");
	printf("- 5 : Putch                      -\r\n");
	printf("- 6 : Putchxy                    -\r\n");
	printf("- 7 : Putchxyt                   -\r\n");
	printf("- 8 : Puts                       -\r\n");
	printf("- 9 : Putsxy                     -\r\n");
	printf("- a : Putsxyt                    -\r\n");
	printf("- b : Line                       -\r\n");
	printf("- c : Rectangle                  -\r\n");
	printf("- d : Rectanglefill              -\r\n");
	printf("- e : Circle                     -\r\n");
	printf("- f : Ellipse                    -\r\n");
	printf("- g : Setcolor(_WHITE)           -\r\n");
	printf("- h : Setcolor(_BLACK)           -\r\n");
	printf("----------------------------------\r\n");
}
