// ======================== Atmega128 ׷ LCD ׽Ʈ α׷ ==============
//  CPU : ATmega128-16M - 128*64 ׷ LCD
//     ¥ : 2008-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : AvrStudio 
//      : serial 19200,N,8,1
// ----------------------------------------------------------------------------
// ⺻ 
#define	__STDIO_FDEVOPEN_COMPAT_12

// ⺻ 
// === AVR includes ===
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
//#include <float.h>
//#include <math.h>

#include "avr/io.h"
#include "avr/interrupt.h"
#include "avr/delay.h"
#include "avr/pgmspace.h"

//  
#include "cpusetup.inc"							// cpu  ͷƮ  ƾ
#include "glcd.inc"							// ׷ LCD

// Լ 
void main_menu_disp(void);						//  ޴ ǥ

//  

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
int main(void)
{
	cpu_setup();							// cpu ʱȭ
	Lcd_Init();							// LCD ʱȭ
	main_menu_disp();						//  ޴ ǥ
	Putsxyt(1,1,"ϼ ѱ TEST");				// ׷ ǥ ڿ ǥ
	Putsxyt(1,2,"www.cpuplaza.com");				// ׷ ǥ ڿ ǥ
	while(1){
		if(com1_rx_eflg){					// COM1  ˻
			if(com1_rx_data == '1') Clrscr();		// ȭ 
			else if(com1_rx_data == '2') Cleardevice();	// ȭ 
			else if(com1_rx_data == '3') Putpixel(0,0,_WHITE);// ȼ ǥ
			else if(com1_rx_data == '4') Putpixelb(0,1,0xff,_WHITE);// Ʈ  ǥ()
			else if(com1_rx_data == '5') Putch('1');	// 1 ǥ
			else if(com1_rx_data == '6') Putchxy(16,2,'2');	// ׷ ǥ 1 ǥ
			else if(com1_rx_data == '7') Putchxyt(8,3,'3');	// ؽƮ ǥ 1 ǥ
			else if(com1_rx_data == '8') Puts("");	// ڿ ǥ
			else if(com1_rx_data == '9') Putsxy(10,3,"׽Ʈ");// ׷ ǥ ڿ ǥ
			else if(com1_rx_data == 'a') Putsxyt(4,2,"׽Ʈ");// ؽƮ ǥ ڿ ǥ
			else if(com1_rx_data == 'b'){			//  پϰ ׸
				Line(0,0,127,0);			// 簢 ڽ
				Line(127,0,127,63);
				Line(127,63,0,63);
				Line(0,0,0,63);

				Line(0,32,127,32);			// +
				Line(64,0,64,63);

				Line(0,0,127,63);			// 밢
				Line(0,63,127,0);
			}
			else if(com1_rx_data == 'c') Rectangle(10,10,118,54);// 簢ڽ ׸
			else if(com1_rx_data == 'd') Rectanglefill(10,10,118,54);// ä 簢ڽ ׸
			else if(com1_rx_data == 'e') Circle(64,32,10);	//  ׸
			else if(com1_rx_data == 'f') Ellipse(64,32,20,10);// Ÿ ׸
			else if(com1_rx_data == 'g') Setcolor(_WHITE);	//   WHITE
			else if(com1_rx_data == 'h') Setcolor(_BLACK);	//   BLACK
			else putchar(com1_rx_data);
			com1_rx_eflg = 0;
		}
	}
	return 0;
}

// =====================================  ޴ ǥ =======================
// [μ] void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	printf("%s","========== LCD Test Main =========\n");
	printf("%s","- 1 : Clrscr                     -\n");
	printf("%s","- 2 : Cleardevice                -\n");
	printf("%s","- 3 : Putpixel                   -\n");
	printf("%s","- 4 : Putpixelb                  -\n");
	printf("%s","- 5 : Putch                      -\n");
	printf("%s","- 6 : Putchxy                    -\n");
	printf("%s","- 7 : Putchxyt                   -\n");
	printf("%s","- 8 : Puts                       -\n");
	printf("%s","- 9 : Putsxy                     -\n");
	printf("%s","- a : Putsxyt                    -\n");
	printf("%s","- b : Line                       -\n");
	printf("%s","- c : Rectangle                  -\n");
	printf("%s","- d : Rectanglefill              -\n");
	printf("%s","- e : Circle                     -\n");
	printf("%s","- f : Ellipse                    -\n");
	printf("%s","- g : Setcolor(_WHITE)           -\n");
	printf("%s","- h : Setcolor(_BLACK)           -\n");
	printf("%s","----------------------------------\n");
}
